package com.setser;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import parsing.Parser;
import parsing.ParsingException;
import parsing.nonterminals.Label;

public class Main extends MIDlet implements CommandListener {

 private TextField code/*, path1, path2*/;
 private Form console;
 private Command ok, back, exit;
 private Display display;
 private String codeToParse;

 public Main(){
  super();
  console = new Form("Console:");
  code = new TextField("Code:", new String(), 500, TextField.ANY);
//  path1 = new TextField("Path to file to compile", new String(), 500, TextField.ANY);
//  path2 = new TextField("Path to folder to save compiled", new String(), 500, TextField.ANY);
  ok = new Command("Ok", Command.OK, 0);
  exit = new Command("Exit", Command.EXIT, 0);
  back = new Command("Back", Command.EXIT, 0);
 }

 public void startApp() {
  if(display==null){
   try{
    display = Display.getDisplay(this);
    console.append(code);
//    console.append(path1);
//    console.append(path2);
    console.addCommand(ok);
    console.addCommand(exit);
    console.setCommandListener(this);
    display.setCurrent(console);
   }catch(Throwable t){
    Alert a = new Alert(t.toString(), t.getMessage(), null, null);
    a.setTimeout(50000);
    Display.getDisplay(this).setCurrent(a);
   }
  }
 }

 public void pauseApp() {
 }

 public void commandAction(Command c, Displayable d){
  if(c==ok){
   try{
    if(code.getString().toCharArray().length<1){
     throw new ParsingException("null input");
    }
    Label.count = 1;
    codeToParse = code.getString();
    Parser parser = new Parser(codeToParse/*, path1.getString(), "file:///"+path2.getString()+"assembled.j"*/);
    Form log = new Form("Log: ");
    log.append(parser.parse());
    log.addCommand(back);
    log.setCommandListener(this);
    display.setCurrent(log);
    log = null;
    System.gc();
   }catch(Throwable t){
    Form log = new Form(t.toString());
    log.append(t.getMessage());
    log.addCommand(back);
    log.setCommandListener(this);
    Display.getDisplay(this).setCurrent(log);
   }
  }else if(c==exit){
   destroyApp(true);
  }else if(c==back){
   display.setCurrent(console);
  }
 }

 public void destroyApp(boolean unconditional) {
  if(unconditional){
   console = null;
   ok = null;
   back = null;
   exit = null;
   code = null;
//   path = null;
   codeToParse = null;
   display = null;
   System.gc();
   notifyDestroyed();
  }
 }
}







