package parsing;

import parsing.nonterminals.Program;
//import java.io.*;
//import javax.microedition.io.Connector;
//import javax.microedition.io.file.FileConnection;

public class Parser
{

 private final char CR = '\n', TAB = '\t', SPACE = ' ';
 private final SymTab keywords = new SymTab(new String[]{"IF", "ELSE", "ENDIF", "WHILE", "ENDWHILE", "READ", "WRITE", "VAR", "BEGIN", "END", "PROGRAM"});
 private final char[] keywordscodes = new String("xileweRWvbep").toCharArray();

 private int count = 0;
 private int linecount = 1, columncount = 1;
 private StringBuffer resultParsing;
 private String code;
 private char Look, token;
 private String value;
// private DataOutputStream dos;
// private DataInputStream dis;

 /**
 * constructor
 */
 public Parser(String codeToParse/*, String pathToLoad, String pathToSave*/)
 {
//  String path=pathToSave;
//  String path2 = pathToLoad;
  code = codeToParse;
  resultParsing = new StringBuffer();
/*  try
  {
   FileConnection fc = (FileConnection)Connector.open(path1);
   FileConnection fin = (FileConnection)Connector.open(path2);
   if(!fin.exists()) throw new ParsingException("file "+pathToLoad+" not found");
   if(fc.exists()) fc.delete();
   fc.create();
   dos = fc.openDataOutputStream();
  }
  catch(IOException ioe)
  {
   throw new ParsingException("file "+path+" not found");
  }*/
  parseCode();
 }
 
 private void parseCode()
 {
  init();
  new Program(this).parse();
 }

 public StringBuffer getResult()
 {
  return resultParsing;
 }

 public void setResult(StringBuffer newResult)
 {
  resultParsing = newResult;
 }

 public String parse()
 {
/*  try
  {
   dos.write(resultParsing.toString().getBytes());
   dos.flush();
   dos.close();
  }
  catch(IOException ioe)
  {
   throw new ParsingException(ioe.getMessage());
  }*/
  return resultParsing.toString();
 }
 
 public void println(String s)
 {
  resultParsing.append(s+'\n');
 }

 public char getLook()
 {
  return Look;
 }

 public char getToken()
 {
  return token;
 }

 public String getValue()
 {
  return value;
 }

 public void getChar()
 {
  /*try
    {
     Look = dis.readChar();
    }
    catch(EOFException eof)
    {
     throw new EOIException("End of file");
    }*/
  try{
   if(count<code.length()){
    Look = code.charAt(count++);
    columncount++;
   }else{
    count = 0;
    throw new EOIException("End of input");
   }
  }catch(StringIndexOutOfBoundsException sioobe){
   throw new EOIException("End of input");
  }
 }
 
 public void abort(String s)
 {
  throw new ParsingException(s+" Line "+linecount+", column "+columncount+".");
 }

 public void expected(String s)
 {
  abort(s+" expected");
 }

 public void match(char x)
 {
  newLine();
  if(Look!=x) expected(x+new String());
  else try{
   getChar();
   skipWhite();
  }catch(EOIException eoi){}
 }

 public void matchString(String s)
 {
  if(!strcmp(s, value)) expected(s);
 }

 public static boolean strcmp(String s1, String s2)
 {
  if(s1.length()!=s2.length()) return false;
  else{
   for(int i = 0; i<s1.length(); i++){
    if(s1.charAt(i)!=s2.charAt(i)) return false;
   }
  }
  return true;
 }

 public boolean isAlpha(char c)
 {
  return (Character.isLowerCase(c)||Character.isUpperCase(c));
 }

 public boolean isDigit(char c)
 {
  return Character.isDigit(c);
 }

 public boolean isAlNum(char c)
 {
  return (isAlpha(c)||isDigit(c));
 }

 public boolean isWhite(char c)
 {
  return (c==SPACE||c==TAB);
 }

 public void scan()
 {
  getName();
  token = keywordscodes[keywords.lookup(value)+1];
 }

 public void getName()
 {
  newLine();
  if(!isAlpha(Look)){
   expected("Name");
  }else{
   value = new String();
   while(isAlNum(Look))
   {
    value+=Character.toUpperCase(Look);
    getChar();
   }
   skipWhite();
  }
 }
 
 public void getNum()
 {
  newLine();
  if(!isDigit(Look)){
   expected("integer");
  }else{
   value = new String();
   while(isDigit(Look))
   {
    value+=Look;
    getChar();
   }
   token = '#';
   skipWhite();
  }
 }

 public void skipWhite()
 {
  while(isWhite(Look)) getChar();
 }

 public void newLine()
 {
  while(Look==CR)
  {
   linecount++;
   columncount = 0;
   getChar();
   skipWhite();
  }
 }

 public void emitLn(String s)
 {
  resultParsing.append(' '+s+'\n');
 }
 
 private void init()
 {
  getChar();
  scan();
 }
}













