package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class BoolExpression extends NonTerminal
{

 private BoolTerm boolterm;

 /**
 * constructor
 */
 public BoolExpression(Parser parser)
 {
  super(parser);
  boolterm = new BoolTerm(parser);
 }

 public void parse()
 {
  boolterm.parse();
  while(isOrop(parser.getLook()))
  {
   switch(parser.getLook())
   {
    case '|':
     or();
     break;
    case '~':
     xor();
     break;
   }
  }
 }

 public void or()
 {
  parser.match('|');
  boolterm.parse();
  CodeGen.popOr();
 }

 public void xor()
 {
  parser.match('~');
  boolterm.parse();
  CodeGen.popXor();
 }
}

