package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class Expression extends NonTerminal
{

 private Term term;

 /**
 * constructor
 */
 public Expression(Parser parser)
 {
  super(parser);
  term = new Term(parser);
 }

 public void parse()
 {
  term.parse();
  while(isAddop(parser.getLook()))
  {
   switch(parser.getLook())
   {
    case '+':
     add();
     break;
    case '-':
     substract();
     break;
   }
  }
 }

 private void add()
 {
  parser.match('+');
  term.parse();
  CodeGen.popAdd();
 }
 
 private void substract()
 {
  parser.match('-');
  term.parse();
  CodeGen.popSub();
 }
}



