package parsing.nonterminals;

import parsing.Parser;
import parsing.SymTab;

public abstract class NonTerminal
{

 protected Parser parser;
 public static NonTerminal nt;
 public static SymTab identifiers;

 /**
 * constructor
 */
 protected NonTerminal(Parser p)
 {
  nt = this;
  parser = p;
  identifiers = new SymTab();
 }
 
 protected void println(String s)
 {
  parser.emitLn(s);
 }
 
 protected String getName()
 {
  parser.getName();
  return parser.getValue();
 }

 protected String getNum()
 {
  parser.getNum();
  return parser.getValue();
 }

 protected boolean isAddop(char c)
 {
  return (c=='+'||c=='-');
 }

 protected boolean isMulop(char c)
 {
  return (c=='*'||c=='/');
 }

 protected boolean isOrop(char c)
 {
  return (c=='|'||c=='~');
 }

 protected boolean isRelop(char c)
 {
  return inArray(c, new char[]{'=', '#', '<', '>'});
 }

 protected boolean inArray(char c, char[] chars)
 {
  for(int i = 0; i<chars.length; i++){
   if(c==chars[i]) return true;
  }
  return false;
 }

 public static boolean inTable(String s){
  return (identifiers.lookup(s)!=-1);
 }

 protected abstract void parse();
}

