package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class Relation extends NonTerminal
{

 private Expression expr;

 /**
 * constructor
 */
 public Relation(Parser parser)
 {
  super(parser);
  expr = new Expression(parser);
 }

 public void parse()
 {
  expr.parse();
  if(isRelop(parser.getLook()))
  {
   switch(parser.getLook())
   {
    case '=':
     equals();
     break;
    case '#':
     notEquals();
     break;
    case '<':
     less();
     break;
    case '>':
     greater();
     break;
   }
  }
 }

 private void lessOrEquals()
 {
  parser.match('=');
  expr.parse();
  CodeGen.setLessOrEqual();
 }

 private void greaterOrEquals()
 {
  parser.match('=');
  expr.parse();
  CodeGen.setGreaterOrEquals();
 }

 private void equals()
 {
  parser.match('=');
  expr.parse();
  CodeGen.setEqual();
 }

 private void notEquals()
 {
  parser.match('>');
  expr.parse();
  CodeGen.setNotEqual();
 }

 private void less()
 {
  parser.match('<');
  switch(parser.getLook())
  {
   case '>':
    notEquals();
    break;
   case '=':
    lessOrEquals();
    break;
   default:
    expr.parse();
    CodeGen.setLess();
    break;
  }
 }

 private void greater()
 {
  parser.match('>');
  switch(parser.getLook())
  {
   case '=':
    greaterOrEquals();
    break;
   default:
    expr.parse();
    CodeGen.setGreater();
    break;
  }
 }
}


