package parsing.nonterminals;
import parsing.Parser;
import codegen.CodeGen;

public class Term extends NonTerminal
{

 private Factor factor;

 /**
 * constructor
 */
 public Term(Parser parser)
 {
  super(parser);
  factor = new Factor(parser);
 }

 public void parse(){
  factor.parse();
  while(parser.getLook()=='*'||parser.getLook()=='/')
  {
   switch(parser.getLook())
   {
    case '*':
     multiply();
     break;
    case '/':
     divide();
     break;
    default:
     parser.expected("Mulop");
     break;
   }
  }
 }

 private void multiply()
 {
  parser.match('*');
  factor.parse();
  CodeGen.popMul();
 }

 private void divide()
 {
  parser.match('/');
  factor.parse();
  CodeGen.popDiv();
 }
}

